/******************************************************************************
Ootake
EWindow\ɂDirectDrawg悤ɂB
E@TVɂȂƂ̉ʂ̖邳ɋ߂Â邽߁AK}グĉʂ𖾂
  ₷B
Eʂg傷ƂɁAhbg̃WM[ڗȂ悤Aʂڂ₯Ă
  ܂Ȃ悤ɁAƎ̊g又(߂̃XLC)Ŋg傷悤
  ɂB
EfBXvC̃tbV[g60Hzł͂ȂꍇAIVSyncIt
  悤ɂB
EDirectDrawVSync҂sۂCPU̗p100%ԂɂȂ̂ŁACPUp[}
  ȓd̓[h(◎)tB
ECƂɉ𑜓xςQ[(120%)ɑΉBv0.60
EXN[ɃeLXgbZ[W̕\ł悤ɂBv0.64

Copyright(C)2006 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

*******************************************************************************
	[DDScreen.c]

	Implement ScreenInterface using Direct Draw.

	Copyright (C) 2004 Ki

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
******************************************************************************/
#define DIRECTDRAW_VERSION	0x0300
#define SOURCE_PITCH 		512		//Kitaoǉ
#define SOURCE_PITCH4 		512*4	//Kitaoǉ

#include <ddraw.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include "DDScreen.h"
#include "Screen.h"
#include "WinMain.h"
#include "Printf.h"
#include "App.h" //Kitaoǉ
#include "math.h" //Kitaoǉ


/*--------------------------------------------------------------------------*
 *                           Static variables                               *
 *--------------------------------------------------------------------------*/
static LPDIRECTDRAW				_pDD         = NULL;  // DirectDraw object
static LPDIRECTDRAWCLIPPER		_pDC         = NULL;  // KitaoǉBDirectDraw clipper object
static LPDIRECTDRAWSURFACE		_pDDSPrimary = NULL;  // DirectDraw primary surface
static LPDIRECTDRAWSURFACE		_pDDSBack    = NULL;  // DirectDraw offscreen surface for BackBuffer
static LPDIRECTDRAWSURFACE		_pDDSText    = NULL;  // DirectDraw offscreen surface for Text

static LONG		_SurfacePitch = 0;

static Sint32	_Width;        // width of display
static Sint32	_Height;       // height of display
static Sint32	_Magnification = 2; //Kitaoǉ
static Uint16*	_pScreenPixels;
static HWND		_hWnd; //Kitaoǉ

static Uint32	_MinimumTimerResolution;

static Uint32	_VirtualTicks;
static Uint32	_VirtualTicksDecimal;

static float	_FPS = 60.0;
static BOOL		_bSkipDraw;

static DWORD	_LastTimeSyncTime = 0;//KitaoǉBOSyncƂ̃^C}[JEg
static BOOL		_bScreen60Hz = TRUE;//KitaoǉB݂̃fBXvCg60Hz̏ꍇTRUEBs(0Hz)̏ꍇTRUEBȊȌꍇFALSEɂV-Sync҂Ȃ悤ɂB


static Sint32	_BitsPerPixel;
static Uint32	_Rmask;
static Uint32	_Gmask;
static Uint32	_Bmask;

static Uint32	_Rshift;
static Uint32	_Gshift;
static Uint32	_Bshift;

static Uint32	_Flags;

static BOOL		_bLocked = FALSE;

static Sint32	_PowerSaving = 17; //KitaoǉBȓd͂Ȃ0`15(lقǏȓd)BȂȂ17B

static Uint8	_Gamma[8]; //KitaoǉBK}vZlĂ
static Uint8	_GammaS80[8]; //KitaoǉBXLC80%p
static Uint8	_GammaS90[8]; //KitaoǉBXLC90%p
static Uint8	_GammaS95[8]; //KitaoǉBXLC95%p

static LONG		_Pitch;
static LONG		_PitchHalf; //KitaoǉBpitch̔ĂBxAbvpB
static Uint16*	_pPixels;

static char*	_pMessageText = ""; //KitaoǉBeLXgbZ[W\pobt@Bki擪0j̏ꍇA\B


/*-----------------------------------------------------------------------------
	[Deinit]
		Finished with all objects we use; release them
-----------------------------------------------------------------------------*/
void
DDSCREEN_Deinit()
{
	if (_pDD != NULL)
	{
		if (_pDC != NULL) //Kitaoǉ
		{
			_pDDSPrimary->lpVtbl->SetClipper(_pDDSPrimary, NULL);
			_pDC->lpVtbl->Release(_pDC);
			_pDC = NULL;
		}

		if (_pDDSText != NULL) //Kitaoǉ
		{
			_pDDSText->lpVtbl->Release(_pDDSText);
			_pDDSText = NULL;
		}

		if (_pDDSBack != NULL)
		{
			_pDDSBack->lpVtbl->Release(_pDDSBack);
			_pDDSBack = NULL;
		}

		if (_pDDSPrimary != NULL)
		{
			_pDDSPrimary->lpVtbl->Release(_pDDSPrimary);
			_pDDSPrimary = NULL;
		}

		_pDD->lpVtbl->Release(_pDD);
		_pDD = NULL;

		_Width  = 0;
		_Height = 0;

		if (timeEndPeriod(_MinimumTimerResolution) != TIMERR_NOERROR)
		{
			// REPORT WARNING
		}
	}
}


static Uint32
get_shift(
	Uint32		mask)
{
	Uint32		i;

	for (i = 0; i < 32; i++)
	{
		if (mask & (1 << i))
		{
			return i;
		}
	}

	return 0;
}


/*-----------------------------------------------------------------------------
	[Init]
		XN[܂B 
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_Init(
	Sint32		width,
	Sint32		height,
	Sint32		magnification, //Kitaoǉ
	Sint32		bitsPerPixel,
	Uint32		flags)
{
	TIMECAPS		tc;
	HRESULT			hRet;
	DDSURFACEDESC	ddsd;
	HWND			hWnd = WINMAIN_GetHwnd();
	int 			a,i; //Kitaoǉ
	double			d; //Kitaoǉ
	DEVMODE			dm; //Kitaoǉ

	hRet = DirectDrawCreate(NULL, &_pDD, NULL);
	if (hRet != DD_OK)
		return FALSE;

	// xݒ肷B 
	if (flags & SCREEN_FFULLSCREEN) //KitaoǉBtXN[[hȂ
		hRet = _pDD->lpVtbl->SetCooperativeLevel(_pDD, hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
	else//Window[hȂ
		hRet = _pDD->lpVtbl->SetCooperativeLevel(_pDD, hWnd, DDSCL_NORMAL);
	if (hRet != DD_OK)
	{
		PRINTF("SetCooperativeLevel() failed.");
		return FALSE;
	}

	// ʂ̉𑜓xݒ肷B
	if (flags & SCREEN_FFULLSCREEN) //KitaoǉBtXN[[hȂ
	{
		hRet = _pDD->lpVtbl->SetDisplayMode(_pDD, width, height, bitsPerPixel);
		if (hRet != DD_OK)
		{
			PRINTF("SetDisplayMode() failed.");
			DDSCREEN_Deinit();
			return FALSE;
		}
	}

	//KitaoǉBfBXvČ݂̕\g߂BV-SyncsǂŎgpB
	memset(&dm, 0, sizeof(DEVMODE));
	dm.dmSize = sizeof(DEVMODE);
	EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &dm);
	if ((dm.dmDisplayFrequency == 60)||(dm.dmDisplayFrequency == 0)) //60Hzsȏꍇ
		_bScreen60Hz = TRUE;
	else
		_bScreen60Hz = FALSE;
	APP_EnableVSyncMenu(_bScreen60Hz); //j[XV

	// vC}T[tFX쐬 
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_VIDEOMEMORY;
	hRet = _pDD->lpVtbl->CreateSurface(_pDD, &ddsd, &_pDDSPrimary, NULL);
	if (hRet != DD_OK)
	{
		PRINTF("CreateSurface() failed.");
		DDSCREEN_Deinit();
		return FALSE;
	}

    // ItXN[T[tFX쐬 
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_VIDEOMEMORY;
	if (magnification == 1)
	 a = 512;
	else //2{ȏ͑Sĉ2{BxAbv{邱ƂœKxɃoCjAtB^|肢ɂȂ
	 a = 512*2;
	ddsd.dwWidth = a;
	ddsd.dwHeight = 224*magnification;
	hRet = _pDD->lpVtbl->CreateSurface(_pDD, &ddsd, &_pDDSBack, NULL);
	if (hRet != DD_OK)
	{
		PRINTF("CreateSurface(Back offscreen surface) failed.");
		DDSCREEN_Deinit();
		return FALSE;
	}

    // KitaoǉBeLXg\pItXN[T[tFX쐬 
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY; //eLXg̓{ēǂ݂ɂȂȂ悤ɃVXeɍ쐬
	if (magnification == 1)
	 a = 512;
	else
	 a = 512*2;
	ddsd.dwWidth = a;
	ddsd.dwHeight = 32;
	hRet = _pDD->lpVtbl->CreateSurface(_pDD, &ddsd, &_pDDSText, NULL);
	if (hRet != DD_OK)
	{
		PRINTF("CreateSurface(Text offscreen surface) failed.");
		DDSCREEN_Deinit();
		return FALSE;
	}

	if (!flags & SCREEN_FFULLSCREEN) //KitaoǉBEBhE[hȂ
	{
		//Nbp[p 
		hRet = _pDD->lpVtbl->CreateClipper(_pDD, 0, &_pDC, NULL);
		if (hRet != DD_OK)
		{
			PRINTF("CreateClipper failed.");
			DDSCREEN_Deinit();
			return FALSE;
		}
		//Nbp[ɃEBhE֘At
		hRet = _pDC->lpVtbl->SetHWnd(_pDC, 0, hWnd);
		if (hRet != DD_OK)
		{
			PRINTF("SetHWnd failed.");
			DDSCREEN_Deinit();
			return FALSE;
		}
		//T[tFXɃNbp[֘At
		hRet = _pDDSPrimary->lpVtbl->SetClipper(_pDDSPrimary, _pDC);
		if (hRet != DD_OK)
		{
			PRINTF("SetClipper failed.");
			DDSCREEN_Deinit();
			return FALSE;
		}
     }

	// Get pixel format 
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_PIXELFORMAT|DDSD_CAPS;
	_pDDSPrimary->lpVtbl->GetSurfaceDesc(_pDDSPrimary, &ddsd);

	_BitsPerPixel = ddsd.ddpfPixelFormat.dwRGBBitCount;
	_Rmask = ddsd.ddpfPixelFormat.dwRBitMask;
	_Gmask = ddsd.ddpfPixelFormat.dwGBitMask;
	_Bmask = ddsd.ddpfPixelFormat.dwBBitMask;

	// Rshift, Gshift, Bshift ߂ 
	_Rshift = get_shift(_Rmask);
	_Gshift = get_shift(_Gmask);
	_Bshift = get_shift(_Bmask);

	// Save our screen resolution
	_Width = width;
	_Height = height;
	_Magnification = magnification;//Kitaoǉ
	_Flags = flags;
	_hWnd =	hWnd;

	//KitaoǉBK}i邳jvZς݂̃e[upӁB
	if ((_Flags & SCREEN_FSCANLINED)&&(_Magnification >= 2)) //XLC̏ꍇAXLCňÂȂԂAK}𖾂߂ɁB
	{
		switch (APP_GetScanLineType())
		{
			case 1: //cXLC
				d = 1.4;
				break;
			case 2: //XLC
				d = 1.3;
				break;
			default:
				d = 1.2;
				break;
		}
	}
	else //mXLC̏ꍇ
		d = 1.2;
	if (_BitsPerPixel == 16)
	{
		for (i = 0; i<=7 ; i++)
		{
			_Gamma[i] = (pow((double)(i << 2) / 32.0, 1.0/d) * 32.0) +0.5;
			_GammaS80[i] = (pow((double)(i << 2)*0.80 / 32.0, 1.0/d) * 32.0) +0.5; //XLC80%p
			_GammaS90[i] = (pow((double)(i << 2)*0.90 / 32.0, 1.0/d) * 32.0) +0.5; //XLC90%p
			_GammaS95[i] = (pow((double)(i << 2)*0.95 / 32.0, 1.0/d) * 32.0) +0.5; //XLC95%p
		}
	}
	else //32rbgJ[̏ꍇ
	{
		for (i = 0; i<=7 ; i++)
		{
			_Gamma[i] = (pow((double)(i << 5) / 256.0, 1.0/d) * 256.0) +0.5;
			_GammaS80[i] = (pow((double)(i << 5)*0.80 / 256.0, 1.0/d) * 256.0) +0.5; //XLC80%p
			_GammaS90[i] = (pow((double)(i << 5)*0.90 / 256.0, 1.0/d) * 256.0) +0.5; //XLC90%p
			_GammaS95[i] = (pow((double)(i << 5)*0.95 / 256.0, 1.0/d) * 256.0) +0.5; //XLC95%p
		}
	}

	if (timeGetDevCaps(&tc, sizeof(tc)) != TIMERR_NOERROR)
	{
		// REPORT WARNING
	}

	_MinimumTimerResolution = tc.wPeriodMin;

	if (timeBeginPeriod(_MinimumTimerResolution) != TIMERR_NOERROR)
	{
		// REPORT WARNING
	}

	_VirtualTicks = timeGetTime();
	_VirtualTicksDecimal = 0;

	_bLocked = FALSE;

	return TRUE;
}


/*-----------------------------------------------------------------------------
	[GetWidth]
	  XN[̉Ԃ܂B
-----------------------------------------------------------------------------*/
Sint32
DDSCREEN_GetWidth()
{
	return _Width;
}


/*-----------------------------------------------------------------------------
	[GetHeight]
	  XN[̍Ԃ܂B
-----------------------------------------------------------------------------*/
Sint32
DDSCREEN_GetHeight()
{
	return _Height;
}


/*-----------------------------------------------------------------------------
	[GetRshift]
	  ꂽOtBbN[hŁCԐFɉrbgVtg邩
	Ԃ܂D(Ⴆ16bppł11C15bppł10)
**---------------------------------------------------------------------------*/
Sint32
DDSCREEN_GetRshift()
{
	return _Rshift;
}


/*-----------------------------------------------------------------------------
	[GetGshift]
	  ꂽOtBbN[hŁCΐFɉrbgVtg邩
	Ԃ܂D(Ⴆ16bppł5C15bppł5)
**---------------------------------------------------------------------------*/
Sint32
DDSCREEN_GetGshift()
{
	return _Gshift;
}


/*-----------------------------------------------------------------------------
	[GetBshift]
	  ꂽOtBbN[hŁCFɉrbgVtg邩
	Ԃ܂D(Ⴆ16bppł0C15bppł0)
**---------------------------------------------------------------------------*/
Sint32
DDSCREEN_GetBshift()
{
	return _Bshift;
}


/*-----------------------------------------------------------------------------
	[GetRmask]
	  ꂽOtBbN[hŁCԐF}XNrbgԂ܂D
	Ԃ܂D(Ⴆ16bppł0xf800, 15bppł 0x7c00)
**---------------------------------------------------------------------------*/
Uint32
DDSCREEN_GetRmask()
{
	return _Rmask;
}


/*-----------------------------------------------------------------------------
	[GetGmask]
	  ꂽOtBbN[hŁCΐF}XNrbgԂ܂D
	Ԃ܂D(Ⴆ16bppł0x07e0, 15bppł 0x03e0)
**---------------------------------------------------------------------------*/
Uint32
DDSCREEN_GetGmask()
{
	return _Gmask;
}


/*-----------------------------------------------------------------------------
	[GetBmask]
	  ꂽOtBbN[hŁCF}XNrbgԂ܂D
	Ԃ܂D(Ⴆ16bppł0x001f, 15bppł 0x001f)
**---------------------------------------------------------------------------*/
Uint32
DDSCREEN_GetBmask()
{
	return _Bmask;
}


/*-----------------------------------------------------------------------------
	[GetBytesPerPixel]
	  PsNZɎgpoCgԂ܂D
**---------------------------------------------------------------------------*/
Uint32
DDSCREEN_GetBytesPerPixel()
{
	return 2;
}


/*-----------------------------------------------------------------------------
	[PutPixel]
	  PsNZ`܂D16bpp p
**---------------------------------------------------------------------------*/
void
DDSCREEN_PutPixel(
	Sint32		x,
	Sint32		y,
	Uint32		pixel)
{
//	if (x > 0 && y > 0 && x < _Width && y < _Height)
//		_pBuf[y * _Width + x] = (Uint16)pixel;
}


/*-----------------------------------------------------------------------------
	[IsFullScreen]
		XN[tXN[Ȃ TRUE, EChEȂ FALSE Ԃ܂B
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_IsFullScreen()
{
	return TRUE;
}


/*-----------------------------------------------------------------------------
	[ToggleFullScreen]
		XN[EChE^tXN[ɐ؂ւ܂D
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_ToggleFullScreen()
{
	return FALSE;
}


/*-----------------------------------------------------------------------------
	[ChangeMode]
		XN[[hύX܂B 
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_ChangeMode(
	Sint32		width,
	Sint32		height,
	Sint32		magnification, //Kitaoǉ
	Sint32		bpp,
	Uint32		flags)
{
	if (_bLocked)
		return FALSE;

	DDSCREEN_Deinit();
	return DDSCREEN_Init(width, height, magnification, bpp, flags);
}


/*-----------------------------------------------------------------------------
	[SetFPS]
		Frames Per Second ύX܂B 
-----------------------------------------------------------------------------*/
void
DDSCREEN_SetFPS(
	float		fps)
{
	_FPS = fps;
}


/*-----------------------------------------------------------------------------
	[WaitVBlank]
		AԂ҂܂B 
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_WaitVBlank(
	BOOL		bForceWait)
{
	Uint32	ticksNow;

	if (_bLocked)
		return FALSE;

	if ((_Flags & SCREEN_FSYNCTO60HZSCREEN)&&(_bScreen60Hz))
	{
		// ̃[h̏ꍇ͂ő҂Aprimary surface  Blt 钼Oő҂ 
		//  bForceWait w肳ꂽꍇ͂ő҂ 
		if (bForceWait)
			_pDD->lpVtbl->WaitForVerticalBlank(_pDD, DDWAITVB_BLOCKBEGIN, NULL);
		return TRUE;
	}

	if (_FPS == 0.0) return TRUE;

	_bSkipDraw = FALSE;

	_VirtualTicksDecimal = (_VirtualTicksDecimal & 0xffff) + (Uint32)(65536.0 * 1000.0 * 1.0 / _FPS);
	_VirtualTicks += _VirtualTicksDecimal >> 16;

	ticksNow = timeGetTime();

	if (ticksNow < _VirtualTicks)
	{
		/*
			zǂ _VirtualTicks - ticksNow < 1/FPS * 1000 ƂȂĂꍇƁC
			_VirtualTicks = 0xffffffff ɋ߂lł ticksNow  wrap around
			Ă܂ĂꍇlDO҂ƌ҂́C
			_VirtualTicks - ticksNow <= 1/FPS * 1000 ǂŔfD
		*/
		if (_VirtualTicks - ticksNow <= (_VirtualTicksDecimal >> 16))
		{
			if (_VirtualTicks - ticksNow > 4) Sleep(_VirtualTicks - ticksNow - 3);
			while (timeGetTime() < _VirtualTicks);
		}
		return TRUE;
	}
	else
	{
		if (ticksNow - _VirtualTicks >= (_VirtualTicksDecimal >> 16) * 4)
		{
			/*
				҂Ԃ 4 {ȏオɌo߂Ăꍇ҂ɕԂD
				4 {ȏ̏ꍇ́uXLbvĂʁvƔfĂ邱ƂɂȂD
			*/
			_VirtualTicks = ticksNow;
			return TRUE;
		}
		else if (ticksNow - _VirtualTicks >= (_VirtualTicksDecimal >> 16) * 2)
		{
			/*
				҂Ԃ̂Q{ȏオɌo߂Ăꍇ
				FALSE ԂD
			*/
			_bSkipDraw = TRUE;
			return FALSE;
		}
		else
		{
			/*
				O񂩂̌oߎԂɑ҂Ԃ𒴂Ăꍇ͉҂ɕԂD
			*/
			return TRUE;
		}
	}

	return TRUE;
}


/*-----------------------------------------------------------------------------
	[ShouldDraw]
		`sȂׂAsȂȂׂԂ܂B 
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_ShouldDraw()
{
	return (_bSkipDraw == FALSE);
}


/*-----------------------------------------------------------------------------
	[Lock]
		XN[bNKv΃bN܂B
-----------------------------------------------------------------------------*/
BOOL
DDSCREEN_Lock()
{
	HRESULT				hRet;
	DDSURFACEDESC		ddsd;
	int					trial = 10;

	if (_bLocked)
		return FALSE;

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	while (trial--)
	{
		hRet = _pDDSPrimary->lpVtbl->Lock(_pDDSPrimary, NULL, &ddsd, DDLOCK_WAIT, NULL);
		if (hRet == DD_OK)
		{
			_pScreenPixels = (Uint16*)ddsd.lpSurface;
			_SurfacePitch = ddsd.lPitch;
			_bLocked = TRUE;
			return TRUE;
		}
		else if (hRet == DDERR_SURFACELOST)
		{
			_pDDSPrimary->lpVtbl->Restore(_pDDSPrimary);
		}
    }

	return FALSE;
}


void*
DDSCREEN_GetBuffer()
{
	if (_bLocked)
		return (void*)_pScreenPixels;

	return NULL;
}


const Sint32
DDSCREEN_GetBufferPitch()
{
	if (_bLocked)
		return _SurfacePitch/2;

	return 0;
}


/*-----------------------------------------------------------------------------
	[Unlock]
		XN[̃bN܂B
-----------------------------------------------------------------------------*/
void
DDSCREEN_Unlock()
{
	if (!_bLocked) return;

	_pDDSPrimary->lpVtbl->Unlock(_pDDSPrimary, NULL);
	_pScreenPixels = NULL;
	_SurfacePitch = 0;
	_bLocked = FALSE;
}


//KitaoǉB\AhԂp̃vC}T[tFX֓]鏈B񓯊B݁A\[X𑜓x256x224ŒB
static void
zoom_ddTensou256()
{
	Sint32		w = 256;
	Sint32		h = 224;
	RECT		rcDst;
	RECT		rcSrc;

	//]̈ʒu 
	SetRect(&rcDst, 0, 0, _Width, _Height);

	//]̈ʒu 
	SetRect(&rcSrc, 0, 0, w, h);

	// vC}T[tFX֓] 
	if (_pDDSPrimary->lpVtbl->Blt(_pDDSPrimary, &rcDst, _pDDSBack, &rcSrc, DDBLT_ASYNC, NULL) == DDERR_SURFACELOST)
		_pDDSPrimary->lpVtbl->Restore(_pDDSPrimary);
}


/*-----------------------------------------------------------------------------
	[DrawText]
		obNobt@݂܂B 
	ĂԑO SCREEN_Lock() ܂傤B
-----------------------------------------------------------------------------*/
void
DDSCREEN_DrawText(
	const Sint32	x,
	const Sint32	y,
	const Uint32	fgColor,
	const Uint32	bgColor,
	const BOOL		bOpaque,
	const char*		pText)
{
	;
}


static BOOL
lock_offscreen_surface(
	LONG*				pPitch,
	Uint16**			ppPixels)
{
	HRESULT				hRet;
	DDSURFACEDESC		ddsd;
	int					trial = 10;

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	while (trial--)
	{
		hRet = _pDDSBack->lpVtbl->Lock(_pDDSBack, NULL, &ddsd, DDLOCK_WAIT, NULL);
		if (hRet == DD_OK)
		{
			*ppPixels = (Uint16*)ddsd.lpSurface;
			*pPitch = ddsd.lPitch;
			return TRUE;
		}
		else if (hRet == DDERR_SURFACELOST)
		{
			_pDDSBack->lpVtbl->Restore(_pDDSBack);
		}
    }

	return FALSE;
}


/*-----------------------------------------------------------------------------
	[FillRect]
		obNobt@Ɏw̐F̋``܂B
	ĂԑO SCREEN_Lock() ܂傤B
-----------------------------------------------------------------------------*/
//KitaoύXBobNobt@ɏޕŏB
//݁Ax,y0ŒB\[X𑜓x256x224ŒB0tBpB32rbgJ[pB݂0tBȂ̂16rbg[hłgB
void
DDSCREEN_FillRect(
	Sint32		x,
	Sint32		y,
	Sint32		width,
	Sint32		height,
	Uint32		color)
{
	Uint16*		pPixels0;
	int			i,j;

	// ̃[hł̓vC}T[tFXɒڏ܂Ȃ̂ Lock  
	DDSCREEN_Unlock();

	if (lock_offscreen_surface(&_Pitch, &_pPixels))
	{
		_PitchHalf = _Pitch / 2;
		pPixels0 = _pPixels;
		for (i = 0; i < 224; i++)
		{
			_pPixels = pPixels0;
			for (j = 0; j < 256; j++)
			{
				*_pPixels++ = 0; //
				*_pPixels++ = 0; //4byteԂ(Phbg)܂B
			}
			pPixels0 += _PitchHalf;
		}
		
		_pDDSBack->lpVtbl->Unlock(_pDDSBack, NULL);

		//vC}T[tFX֓]
		zoom_ddTensou256();
	}
}


//KitaoǉBeLXgbZ[Wݒ
void
DDSCREEN_SetMessageText(
	char*	pText)
{
	_pMessageText = pText;
}


//KitaoǉBeLXgbZ[W̕\
static void
print_message()
{
	HDC			dc;
	HFONT		prevFont;
	HFONT		hFont;
	LOGFONT		logFont;
	RECT		rcSrc;
	RECT		rcDst;
	RECT		rc;

	if (_pDDSText->lpVtbl->GetDC(_pDDSText, &dc) == DD_OK)
	{
		hFont = GetStockObject(DEFAULT_GUI_FONT);
		GetObject(hFont, sizeof(LOGFONT), &logFont);
		logFont.lfHeight = 16;
		logFont.lfWidth = 0;
		hFont = CreateFontIndirect(&logFont);
		prevFont = SelectObject(dc, hFont);
		
		rc.left		= 0;
		rc.right	= 0;
		rc.top		= 0;
		rc.bottom	=16;
		SetBkColor(dc, RGB(48,96,48));
		SetTextColor(dc, RGB(255,255,255));
		DrawText(dc, _pMessageText, lstrlen(_pMessageText), &rc,
				 DT_CALCRECT | DT_SINGLELINE | DT_NOPREFIX); //\V~[VBrcɕ\Ƃ̃TCYB
		DrawText(dc, _pMessageText, lstrlen(_pMessageText), &rc, DT_SINGLELINE | DT_NOPREFIX); //\
		
		SelectObject(dc, prevFont);
		DeleteObject(hFont);
		_pDDSText->lpVtbl->ReleaseDC(_pDDSText, dc);
		
		// obNT[tFX֓] 
		rcSrc.left	= 0;
		rcSrc.top	= 0;
		rcSrc.right	= rc.right;
		if (rcSrc.right > _Width)
			rcSrc.right	= _Width;
		rcSrc.bottom= 16;
		//ux4vux3XLCv̂Ƃ́A\͈̔͂cɂQ{g傷B
		rcDst.left	= 3 -_Magnification/3;
		rcDst.top	= 4;
		rcDst.right	= rcDst.left + rcSrc.right;
		if ((_Magnification == 4)||
			((_Magnification == 3)&&(_Flags & SCREEN_FSCANLINED)))
			rcDst.bottom = 4+32;
		else
			rcDst.bottom = 4+16;
		//rcDst.top = 224*_Magnification - abs(logFont.lfHeight) -3; //ɕ\p
		//rcDst.bottom = 224*_Magnification -3; //ɕ\p
		if (_pDDSBack->lpVtbl->Blt(_pDDSBack, &rcDst, _pDDSText, &rcSrc, DDBLT_ASYNC, NULL) == DDERR_SURFACELOST)
			_pDDSBack->lpVtbl->Restore(_pDDSBack);
	}
}


//KitaoǉBvC}T[tFX֓]鏈ȂǁB
static void
zoom_ddTensou(
	Sint32		w,	//]̉sNZ
	Sint32		h)	//]̏csNZ
{
	RECT		rcSrc;
	RECT		rcDst;
	RECT		rc;
	Sint32		a,b,w2,h2;
	Sint32		t;

	//eLXgbZ[W̕\
	if (*_pMessageText != 0) //bZ[Wݒ肳Ă
		print_message();

	//]̈ʒu 
	if (_Flags & SCREEN_FFULLSCREEN)
	{
		if (_Flags & SCREEN_FSTRETCHED)
		{
			if (_Flags & SCREEN_FVSTRETCHED) //cʃ[hȂ
				w2 = (Sint32)((double)(299*_Magnification)* (256.0/336.0)); //@l256:336̔ŏki256ȊÕQ[lɉ\j
			else
				w2 = 299*_Magnification;
			a = (_Width - w2) / 2;
			b = (_Height - 224*_Magnification) / 2;
			SetRect(&rcDst, a, b, a+w2, b+224*_Magnification); //AXyNgTVʂƓSFRɁBc̒PCEW224̐{(Q{)ɂ
		}
		else //Xgb`Ȃꍇ
		{
			w2 = w*_Magnification;
			h2 = h*_Magnification;
			a = (_Width - w2) / 2;
			b = (_Height - h2) / 2;
			SetRect(&rcDst, a, b, a+w2, b+h2);
		}
	}
	else //EBhE[ĥƂBEBhE[ĥƂ́AApp.cłłɓ]̃EBhETCY𒲐ς݁BXgb`̗L֌WȂEBhEςɓ]B
	{
		GetWindowRect(_hWnd, &rc);
		a = rc.left + (rc.right - rc.left - _Width)/2;
		b = rc.bottom - (rc.right - rc.left - _Width)/2 - _Height; //g̑ƕ\̈̍Ԃ
		SetRect(&rcDst, a, b, a+_Width, b+_Height);
	}

	//]̈ʒu 
	if (_Magnification >= 2) //Qȏ̏ꍇ
	{
		if (_Flags & SCREEN_FSCANLINED)
		{
			w *= 2; //͂Q{hbgŒBixAbv{g傳ꂽƂɃoCjAtB^ɂj
			h *= _Magnification; //c͔{Ԃ̃\[Xpӂē]B
		}
		else
		{
			w *= 2; //͂Q{hbgŒBixAbv{g傳ꂽƂɃoCjAtB^ɂj
			if (_Magnification == 2)
				h *= _Magnification; //c͔{Ԃ̃\[Xpӂē]B
			else
				h *= _Magnification-1; //3x,4x̂Ƃ́Aꂼ2x,3xɊgBiWM[yxAbvj
		}
	}
	SetRect(&rcSrc, 0, 0, w, h);

	// VBL  ҂ 
	if ((_Flags & SCREEN_FSYNCTO60HZSCREEN)&&(_bScreen60Hz))
	{
		//KitaoǉB̃Av̂߂ɏx݁BȂWaitForVerticalBlank()ő҂ĂԂCPUL100%ɂȂB
		t = 16 - (timeGetTime() - _LastTimeSyncTime) - _PowerSaving; //16=PR}̎Ԗ16msB-4͏Ȃ߂̃}[WB
		if ((t >= 0)&&(t <= 16-_PowerSaving)) //^C}[JE^̃I[o[t[lāA͈̔͂̂ƂSleepȂB
			Sleep(t);
		//҂
		_pDD->lpVtbl->WaitForVerticalBlank(_pDD, DDWAITVB_BLOCKBEGIN, NULL);
		_LastTimeSyncTime = timeGetTime(); //OSyncI^CƂċL^Ă
	}

	// vC}T[tFX֓] 
	if (_pDDSPrimary->lpVtbl->Blt(_pDDSPrimary, &rcDst, _pDDSBack, &rcSrc, DDBLT_ASYNC, NULL) == DDERR_SURFACELOST)
		_pDDSPrimary->lpVtbl->Restore(_pDDSPrimary);
}


/*
	n[hEFAɗXgb``惂[h
	VRAM  VRAM ]
	(Xgb`ꂽꍇoCjA⊮)
*/
//KitaoXVBzoom3x()Czoom2x()Czoom1x()pӁBxd̂߂ꂼʃ[`ɁB
static void
zoom4x_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint16		a; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ95%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS95[r] << _Rshift)|(_GammaS95[g] << gshift) | _GammaS95[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS95[r] << _Rshift)|(_GammaS95[g] << gshift) | _GammaS95[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Rڂ90%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			a =(_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b];
			*pDst++ = a; //2byteԂ(1hbg)܂
			*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = a; //2byteԂ(1hbg)܂
					*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVB32rbgJ[ɂΉB
static void
zoom4x_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ95%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS95[g] << 8)| _GammaS95[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS95[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS95[g] << 8)| _GammaS95[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS95[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Rڂ90%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVB16rbgJ[xR{p
static void
zoom3x_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint16		a; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ90%XLCɂB
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			a =(_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b];
			*pDst++ = a; //2byteԂ(1hbg)܂
			*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = a; //2byteԂ(1hbg)܂
					*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVB32rbgJ[xR{p
static void
zoom3x_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ90%XLCɂB
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g
				}
		}
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVBx216rbgJ[pB
static void
zoom2x_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint16		a; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b]; //2byteԂ(1hbg)܂BQ{g
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			a = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b];//RGB
			*pDst++ = a; //2byteԂ(1hbg)܂
			*pDst++ = a; //2byteԂ(1hbg)܂BQ{g
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = a; //2byteԂ(1hbg)܂
					*pDst++ = a; //2byteԂ(1hbg)܂BQ{g
				}
		}
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVBx232rbgJ[pB
static void
zoom2x_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉBXLC16rbgJ[xS{pBxd̂߂ꂼʃ[`ɁB
static void
zoom4xHS_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint16		a; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ95%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS95[r] << _Rshift)|(_GammaS95[g] << gshift) | _GammaS95[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS95[r] << _Rshift)|(_GammaS95[g] << gshift) | _GammaS95[b]; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS95[r] << _Rshift)|(_GammaS95[g] << gshift) | _GammaS95[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS95[r] << _Rshift)|(_GammaS95[g] << gshift) | _GammaS95[b]; //2byteԂ(1hbg)܂
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Rڂ90%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
				}
		}
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			a =(_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b];
			*pDst++ = a; //2byteԂ(1hbg)܂
			*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = a; //2byteԂ(1hbg)܂
					*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉBXLC32rbgJ[xS{p
static void
zoom4xHS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ95%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS95[g] << 8)| _GammaS95[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS95[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS95[g] << 8)| _GammaS95[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS95[r]; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS95[g] << 8)| _GammaS95[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS95[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS95[g] << 8)| _GammaS95[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS95[r]; //2byteԂ(hbg)܂B
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Rڂ90%XLC
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
				}
		}
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉBXLC16rbgJ[xR{p
static void
zoom3xHS_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint16		a; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ90%XLCɂB
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_GammaS90[r] << _Rshift)|(_GammaS90[g] << gshift) | _GammaS90[b]; //2byteԂ(1hbg)܂
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			a =(_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b];
			*pDst++ = a; //2byteԂ(1hbg)܂
			*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = a; //2byteԂ(1hbg)܂
					*pDst++ = a; //2byteԂ(1hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉBXLC32rbgJ[xR{p
static void
zoom3xHS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++) //Qڂ90%XLCɂB
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS90[g] << 8)| _GammaS90[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS90[r]; //2byteԂ(hbg)܂B
				}
		}
		pDst = pDst0 + _Pitch;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g
				}
		}
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉBx2̉XLC16rbgJ[pB
static void
zoom2xHS_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint16		a; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
					*pDst++ = (_Gamma[r] << _Rshift)|(_Gamma[g] << gshift) | _Gamma[b]; //2byteԂ(1hbg)܂
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			a = (_GammaS80[r] << _Rshift)|(_GammaS80[g] << gshift) | _GammaS80[b];//RGB
			*pDst++ = a; //2byteԂ(1hbg)܂
			*pDst++ = a; //2byteԂ(1hbg)܂BQ{g
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = a; //2byteԂ(1hbg)܂
					*pDst++ = a; //2byteԂ(1hbg)܂BQ{g
				}
		}
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉBx2̉XLC32rbgJ[pB
static void
zoom2xHS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// XLC80%
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
			*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_Gamma[g] << 8)| _Gamma[b]; //2byteԂ(hbg)܂B
					*pDst++ = _Gamma[r]; //2byteԂ(hbg)܂B
				}
		}
		pDst = pDst0 + _PitchHalf;
		pSrc8 = pSrc0;
		for (j = 0; j < sw; j++)
		{
			b = *pSrc8++;
			g = *pSrc8++;
			r = *pSrc8++;
			pSrc8++;
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
			*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
			*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂B
					*pDst++ = (_GammaS80[g] << 8)| _GammaS80[b]; //2byteԂ(hbg)܂B
					*pDst++ = _GammaS80[r]; //2byteԂ(hbg)܂BQ{g(80%cXLC)
				}
		}
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVBmXLCpB2x3x4x16rbgJ[Bxd̂߃XLCpƏ𕪂B
static void
zoom2x3x4xNS_dd16(
	int			bairitsu,		// 2x3x4xB2xȂ2B3xȂ3B4xȂ4B
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j,k; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	int			bairitsu2; //KitaoǉBc̃hbg{ɃfW^g傷邩B2x3xȂ2B4xȂ3B
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (bairitsu == 2)
		bairitsu2 = 2;
	else
		bairitsu2 = bairitsu -1;

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// XLCȂ
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (k = 1; k <= bairitsu2; k++) //cbairitsu{ɃfW^g傷
		{
			pSrc8 = pSrc0;
			pDst = pDst0;
			for (j = 0; j < sw; j++)
			{
				b = _Gamma[*pSrc8++];
				g = _Gamma[*pSrc8++];
				r = _Gamma[*pSrc8++];
				pSrc8++;
				*pDst++ = (r << _Rshift)|(g << gshift) | b; //2byteԂ(1hbg)܂
				*pDst++ = (r << _Rshift)|(g << gshift) | b; //2byteԂ(1hbg)܂BQ{g(XLCȂ)
				if (((j & 1)&&((j & 15)>2))||(pw == 15))
					if ((j & 15) <= pw)
					{	//Q{g
						*pDst++ = (r << _Rshift)|(g << gshift) | b; //2byteԂ(1hbg)܂
						*pDst++ = (r << _Rshift)|(g << gshift) | b; //2byteԂ(1hbg)܂BQ{g(XLCȂ)
					}
			}
			pDst0 += _PitchHalf;
		}
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoXVBmXLC2x3x4xB32rbgJ[p
static void
zoom2x3x4xNS_dd32(
	int			bairitsu,		// 2x3x4xB2xȂ2B3xȂ3B4xȂ4B
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			// eC̕BKitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j,k; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	int			bairitsu2; //KitaoǉBc̃hbg{ɃfW^g傷邩B2x3xȂ2B4xȂ3B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (bairitsu == 2)
		bairitsu2 = 2;
	else
		bairitsu2 = bairitsu -1;

	// XLCȂ
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (k = 1; k <= bairitsu2; k++) //cbairitsu{ɃfW^g傷
		{
			pSrc8 = pSrc0;
			pDst = pDst0;
			for (j = 0; j < sw; j++)
			{
				b = _Gamma[*pSrc8++];
				g = _Gamma[*pSrc8++];
				r = _Gamma[*pSrc8++];
				pSrc8++;
				*pDst++ = (g << 8)| b; //2byteԂ(hbg)܂B
				*pDst++ = r; //2byteԂ(hbg)܂B
				*pDst++ = (g << 8)| b; //2byteԂ(hbg)܂B
				*pDst++ = r; //2byteԂ(hbg)܂BQ{g(XLCȂ)
				if (((j & 1)&&((j & 15)>2))||(pw == 15))
					if ((j & 15) <= pw)
					{	//Q{g
						*pDst++ = (g << 8)| b; //2byteԂ(hbg)܂B
						*pDst++ = r; //2byteԂ(hbg)܂B
						*pDst++ = (g << 8)| b; //2byteԂ(hbg)܂B
						*pDst++ = r; //2byteԂ(hbg)܂BQ{g(XLCȂ)
					}
			}
			pDst0 += _PitchHalf;
		}
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉB16rbgJ[xP{pBXLCȂ
static void
zoom1xNS_dd16(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW,			 //Kitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Uint32		gshift; //KitaoǉBRGB555̂Ƃ5BRGB565̂Ƃ6B
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	if (_Rshift == 10) //RGB555̂Ƃ
		gshift = 5;
	else //RGB565̂Ƃ
		gshift = 6;

	// P{Ȃ̂ŃXLC͂Ȃ
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = _Gamma[*pSrc8++];
			g = _Gamma[*pSrc8++];
			r = _Gamma[*pSrc8++];
			pSrc8++;
			*pDst++ = (r << _Rshift)|(g << gshift) | b; //2byteԂ(1hbg)܂
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
					*pDst++ = (r << _Rshift)|(g << gshift) | b; //Q{g
		}
		pDst0 += _PitchHalf;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}
}

//KitaoǉB32rbgJ[xP{pBXLCȂ
static void
zoom1xNS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		dstW,			// ]̕
	Sint32		dstH,			// ]̍
	Uint16*		pTvW, 			//Kitaoǉ
	Sint32		srcW,			// ]̕
	Sint32		srcH,			// ]̍
	Sint32		dstPitch)		// in pixel
{
	Uint8*		pSrc8 =	(Uint8*)pSrc; //Kitaoǉ
	int			i,j; //Kitaoǉ
	int			sw,pw; //Kitaoǉ
	Uint8*		pSrc0; //Kitaoǉ
	Uint16*		pDst; //Kitaoǉ
	Uint16*		pDst0; //Kitaoǉ
	Uint8		r,g,b; //Kitaoǉ
	Sint32		srcW2 = srcW / 2; //Kitaoǉ

	// P{Ȃ̂ŃXLC͖
	pSrc0 = pSrc8;
	pDst0 = _pPixels;
	for (i = 0; i < srcH; i++)
	{
		pSrc8 = pSrc0;
		pDst = pDst0;
		if (*pTvW == srcW)
		{
			sw = srcW;
			pw = -1;
		}
		else if (*pTvW <= srcW2) //̃C̉𑜓xő𑜓x̔ȉꍇ(256512)
		{
			sw = srcW2;
			pw = 15; //hbg2{Ɋg債ď
		}
		else //̃C̉𑜓xő𑜓x⏬ꍇ(256336)
		{
			sw = 256;
			pw = 11; //16hbĝT񂾂Q{`BʁAhbg1.3125{Ɋg債ďނƂɂȂB
		}
		for (j = 0; j < sw; j++)
		{
			b = _Gamma[*pSrc8++];
			g = _Gamma[*pSrc8++];
			r = _Gamma[*pSrc8++];
			pSrc8++;
			*pDst++ = (g << 8)| b; //2byteԂ(hbg)܂B
			*pDst++ = r; //2byteԂ(hbg)܂B
			if (((j & 1)&&((j & 15)>2))||(pw == 15))
				if ((j & 15) <= pw)
				{	//Q{g
					*pDst++ = (g << 8)| b; //2byteԂ(hbg)܂B
					*pDst++ = r; //2byteԂ(hbg)܂B
				}
		}
		pDst0 += _PitchHalf;
		pSrc0 += SOURCE_PITCH4;
		*pTvW++;
	}

}


/*-----------------------------------------------------------------------------
	[Blt]
		pSrc obNobt@։摜݂܂Bg^kA
	ĂԑO SCREEN_Lock() ܂傤B
-----------------------------------------------------------------------------*/
void
DDSCREEN_Blt(
	const void*		pSrc,
	Sint32			srcX,
	Sint32			srcY,
	Sint32			dstX,
	Sint32			dstY,
	Uint16*			pTvW, //Kitaoǉ
	Sint32			srcW,
	Sint32			srcH,
	Sint32			dstW,
	Sint32			dstH)
{
//	int		i;
	Uint32	dstPitch	= _SurfacePitch / 2;
	Uint32*	pSrc32		= (Uint32*)pSrc + srcY * 512 + srcX; //KitaoXV

	if (_pScreenPixels == NULL || pSrc == NULL)
		return;

	//KitaoXVBKn[hEFAANZ[VgpB
	DDSCREEN_Unlock(); // vC}T[tFXɒڏ܂Ȃ̂ Lock  
	if (lock_offscreen_surface(&_Pitch, &_pPixels)) //obNT[tFXbN
	{
		_PitchHalf = _Pitch / 2;
		
		//KitaoXVBxd̂߂ꂼ̉ʃ[hŁAʁX̃[`gB
		if (_Flags & SCREEN_FSCANLINED)
		{
			switch (APP_GetScanLineType())
			{
				case 1: //cXLC
					switch (_Magnification)
					{
						case 1:
							if (_BitsPerPixel<=16)
								zoom1xNS_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom1xNS_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
						case 2:
							if (_BitsPerPixel<=16)
								zoom2x_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom2x_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
						case 3:
							if (_BitsPerPixel<=16)
								zoom3x_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom3x_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
						case 4:
							if (_BitsPerPixel<=16)
								zoom4x_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom4x_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
					}
					break;
				case 2: //̂݃XLC
					switch (_Magnification)
					{
						case 1:
							if (_BitsPerPixel<=16)
								zoom1xNS_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom1xNS_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
						case 2:
							if (_BitsPerPixel<=16)
								zoom2xHS_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom2xHS_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
						case 3:
							if (_BitsPerPixel<=16)
								zoom3xHS_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom3xHS_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
						case 4:
							if (_BitsPerPixel<=16)
								zoom4xHS_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
							else
								zoom4xHS_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
							break;
					}
					break;
				//case 3: //ĉ݃XLCijB4ȍ~ɂGtFNgłB
			}
		}
		else //mXLC̏ꍇ
		{
			switch (_Magnification)
			{
				case 1:
					if (_BitsPerPixel<=16)
						zoom1xNS_dd16(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
					else
						zoom1xNS_dd32(pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
					break;
				case 2:
				case 3:
				case 4:
					if (_BitsPerPixel<=16)
						zoom2x3x4xNS_dd16(_Magnification, pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //16bitJ[
					else
						zoom2x3x4xNS_dd32(_Magnification, pSrc32, dstW, dstH, pTvW, srcW, srcH, dstPitch); //32bitJ[
					break;
			}
		}
		
		//bN
		_pDDSBack->lpVtbl->Unlock(_pDDSBack, NULL);
		
		//vC}T[tFX֓]
		zoom_ddTensou(srcW, srcH);
	}
}


//KitaoǉB_PowerSavingݒ肷B
void
DDSCREEN_SetPowerSaving(
	Sint32	powersaving)
{
	_PowerSaving = powersaving;
}

